local VertifyPetButtonID = function(id)
	if(type(Button) == "string") then
		Button = ToTable(Button);
	end
	if(type(Button) == "table") then
		for _, id in ipairs(Buttons) do
			id = tonumber(id)
			if(not (id < 11 and id > 0)) then
				return "invalid PetButtonID (valid IDs 1-10)"
			end
		end
		return true
	else
		return false
	end
end

local function ToTable(range)
	Table = {};
	-- If we get "*" then get a table of all possible values
	if(range == "*") then
		Table = {1, 2, 3, 4, 5, 6, 7, 8, 9, 10};
	-- try to match a range (number)-(number)
	elseif(range:find("%d+-%d+")) then
		local _, _, First, Last = range:find("^(%d+)-(%d+)$");
		for Number = First, Last do
			table.insert(Table, tostring(Number));
		end
	-- Try to match a table (name);(name);(name);...
	elseif(range:find("[%w_];[%w_]")) then
		Table = { string.split(";", range) };
	-- No match, just assume the given string is a valid petbutton id, for now.
	else
		Table = { range };
	end
	return Table
end

-- /fb setPetButton command
local function SlashCommand_SetPetButton(Params)
	local ButtonTable = FlexBar2:ToButtonTable(Params.button);
	local PetIdTable = ToTable(Params.petbutton)
	local ButtonList = FlexBar2.Buttons;
	
	if #PetIdTable == 1 then
		for _, ButtonName in ipairs(ButtonTable) do
			ButtonList[ButtonName]:SetPetButton(Params.petbutton)
		end
		
	elseif #PetIdTable > 1 then
		if(Params.petbutton ~= "" and #ButtonTable ~= #PetIdTable) then FlexBar2:Print("number of petbuttonids given does not match the numbers of buttons given"); return; end
		
		for i, ButtonName in ipairs(ButtonTable) do
			ButtonList[ButtonName]:SetPetButton(PetIdTable[i])
		end
		
	end
end
-- /fb buildNewPetbar command
local function SlashCommand_BuildNewPetbar(Params)
	local petbar = FlexBar2:GetModule("PetBar")
	petbar:BuildNewPetBar()
end

local SlashCommands = FlexBar2.SlashCommands;
-- Localize this neat verify function for faster access
local VerifyExistance = FlexBar2.SlashCommands.VerifyExistance;
-- AddCommand format :AddCommand(Command, Function, Group, Help)
-- AddParam format :AddParam(Command, Param, Required, AllowedValues, DefaultValue, VerifyFunc) 
-- everything here should be self explainative knowing the syntax
SlashCommands:AddCommand("setpetbutton", SlashCommand_SetPetButton, "petbar", "button=<Button> petbutton=<PetButtonID>");
SlashCommands:SetAlias("setpetbutton", "petbtn");
SlashCommands:AddParam("setpetbutton", "button", true, nil, nil, VerifyExistance);
SlashCommands:AddParam("setpetbutton", "petbutton", true, nil, "1", VertifyPetButtonID);
-- /fb setpetbutton button=8 petbutton=8
SlashCommands:AddCommand("buildnewpetbar", SlashCommand_BuildNewPetbar, "petbar", "");
SlashCommands:SetAlias("buildnewpetbar", "createpetbar");

