
if(FlexBar2:HasModule("Tooltip")) then
	local Tooltip = FlexBar2:GetModule("Tooltip");
	
	-- hook the ShowTooltip func to support the pet attribute
	Tooltip.ButtonMixin.OrigShowTooltip = Tooltip.ButtonMixin.ShowTooltip
	
	function Tooltip.ButtonMixin:ShowTooltip()
		-- call orginal
		self:OrigShowTooltip()
		
		
		-- if no tooltip is shown, check if there can be one shown based on the pet attribute
		if not GameTooltip:IsShown() then
			local petBtnId = self:GetPetButtonIndex()
			local name, subtext, _, isToken, _, _, _ = self:GetPetButtonData(petBtnId)
			
			if name and petBtnId then
				GameTooltip_SetDefaultAnchor(GameTooltip, self.Frame);
				
				-- shortend blizz way to handle the petbar button tooltips
				local uber = GetCVar("UberTooltips");
				if ( isToken or (uber == "0") ) then
					
					GameTooltip:SetText(name, 1.0, 1.0, 1.0);
					
					if ( subtext ) then
						GameTooltip:AddLine(subtext, "", 0.5, 0.5, 0.5);
					end
					GameTooltip:Show();
				else
					GameTooltip:SetPetAction(petBtnId);
					GameTooltip:Show();
				end
			end
		end
	end
	
end



